## opencamlib 2023.01.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.25)

project(OpenCAMLib LANGUAGES CXX)

set( CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR}/src )
add_subdirectory( src )

=== docs/requirements.txt ===
breathe
sphinx
sphinx-rtd-theme

=== src/CMakeLists.txt ===
project(OpenCAMLib LANGUAGES CXX)

set(CMAKE_VERBOSE_MAKEFILE ON)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0025 NEW)
  cmake_policy(SET CMP0091 NEW) # for multithreaded  https://cmake.org/cmake/help/latest/policy/CMP0091.html
  cmake_policy(SET CMP0094 NEW) # for Python*_FIND_STRATEGY=LOCATION
  cmake_policy(SET CMP0042 NEW)
  cmake_policy(SET CMP0054 NEW)
endif(COMMAND cmake_policy)

# install targets in root of the build dir, using $<0:> generator expression to force it from not being overwritten
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
endforeach()

set(CMAKE_CXX_STANDARD 14)

if(WIN32)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
endif()

# some options to set what is built:
option(BUILD_CXX_LIB
  "Build/install the pure c++ ocl library? " OFF)

option(BUILD_PY_LIB
  "Build/install the python ocl library? " OFF)

option(BUILD_NODEJS_LIB
  "Build/install the node.js ocl library? " OFF)

option(BUILD_DOC
  "Build/install the ocl documentation? " ON)

option(USE_OPENMP
    "Use OpenMP for parallel computation" ON)

option(VERSION_STRING
    "Set version string")

option(USE_PY_3
    "Use Python V3" ON)

if(NOT BUILD_CXX_LIB)
  message(STATUS " Note: will NOT build pure c++ library")
endif()

if(NOT BUILD_PY_LIB)
  message(STATUS " Note: will NOT build python library")
endif()

if(NOT BUILD_NODEJS_LIB)
  message(STATUS " Note: will NOT build node.js library")
endif()

if(NOT BUILD_EMSCRIPTEN_LIB)
  message(STATUS " Note: will NOT build emscripten library")
endif()

if(NOT BUILD_DOC)
  message(STATUS " Note: will NOT build ocl documentation")
endif()

# figure out the gcc version
include(gcc_version.cmake)

#
# Turn compiler warnings up to 11, at least with gcc.  I don't know how to
# do this with other compilers we might support and I'm leaving it up to
# the relevant platform maintainers...
# #include'ing the boost graph-library creates deprecated warnings
# thus we use now use -Wno-deprecated here.
#
if(UNIX)
  if(GCC_4_6)
    message(STATUS "setting gcc options: -Wall -Werror -Wno-deprecated -pedantic-errors")
    add_definitions(-Wall  -Wno-deprecated -Werror -pedantic-errors)
  else()
    message(STATUS "setting gcc options: -Wall  -Wno-deprecated -pedantic-errors")
    add_definitions(-Wall  -Wno-deprecated -pedantic-errors)
  endif()
endif()

include(CheckIPOSupported)
check_ipo_supported(RESULT got_ipo_support)
if(got_ipo_support)
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(Boost_DEBUG ON CACHE BOOL "boost-debug")
set(Boost_USE_STATIC_LIBS ON CACHE BOOL "boost-use-static-libs")
if(DEFINED ENV{BOOST_ROOT} OR DEFINED BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS ON)
endif()
if(CMAKE_BUILD_TYPE MATCHES Debug)
	set(Boost_USE_DEBUG_LIBS     ON)
	set(Boost_USE_RELEASE_LIBS   OFF)
else()
	set(Boost_USE_DEBUG_LIBS     OFF)
	set(Boost_USE_RELEASE_LIBS   ON)
endif()
if(BUILD_EMSCRIPTEN_LIB)
  set(Boost_USE_MULTITHREADED  OFF)
elseif(USE_OPENMP)
  set(Boost_USE_MULTITHREADED  ON)
endif()
if(WIN32)
  # use static python lib
  if(Boost_USE_STATIC_LIBS)
    add_definitions(-D BOOST_PYTHON_STATIC_LIB)
  endif()
  # disable autolinking in boost
  add_definitions(-D BOOST_ALL_NO_LIB) # avoid LNK1104 on Windows: http://stackoverflow.com/a/28902261/122441
endif()

# when building the emscripten we have to temporarily set
# the root path mode to BOTH so Boost can be found
if(BUILD_EMSCRIPTEN_LIB)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE BOTH)
  set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE BOTH)
endif()
find_package(Boost REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
if(BUILD_EMSCRIPTEN_LIB)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
endif()

if(USE_OPENMP)
  if(APPLE)
    if(DEFINED ENV{OPENMP_PREFIX_MACOS})
      message(STATUS "Will use libomp at $ENV{OPENMP_PREFIX_MACOS}.")
      set(OpenMP_C_FLAGS "-Xpreprocessor -fopenmp")
      set(OpenMP_C_LIB_NAMES "omp")
      set(OpenMP_CXX_FLAGS "-Xpreprocessor -fopenmp")
      set(OpenMP_CXX_LIB_NAMES "omp")
      set(OpenMP_omp_LIBRARY "$ENV{OPENMP_PREFIX_MACOS}/lib/libomp.dylib")
      include_directories("$ENV{OPENMP_PREFIX_MACOS}/include")
    else()
      list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/libomp")
      list(APPEND CMAKE_PREFIX_PATH "/opt/homebrew/opt/libomp")
    endif()
  endif()
  find_package(OpenMP REQUIRED)
  if(OPENMP_FOUND)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    message(STATUS "found OpenMP, compiling with flags: " ${OpenMP_CXX_FLAGS} )
    include_directories(${OpenMP_CXX_INCLUDE_DIRS})
  endif()
endif()

if(EXISTS ${PROJECT_SOURCE_DIR}/version_string.hpp)
  file(STRINGS "${PROJECT_SOURCE_DIR}/version_string.hpp" PROJECT_BUILD_SPECIFICATION REGEX "^[ \t]*#define[ \t]+VERSION_STRING[ \t]+.*$")
  if(PROJECT_BUILD_SPECIFICATION)
    string(REGEX REPLACE ".*#define[ \t]+VERSION_STRING[ \t]+\"(.*)\".*" "\\1" MY_VERSION ${PROJECT_BUILD_SPECIFICATION})
  else()
    message(FATAL_ERROR "Data were not found for the required build specification.")
  endif()
  set(version_string ${PROJECT_SOURCE_DIR}/version_string.hpp)
else()
  ################ create version_string.hpp, http://stackoverflow.com/questions/3780667
  # include the output directory, where the version_string.hpp file is generated
  include_directories(${CMAKE_CURRENT_BINARY_DIR})
  if(VERSION_STRING)
    set( vstring "//version_string.hpp - written by cmake. changes will be lost!\n"
               "#ifndef VERSION_STRING\n"
               "#define VERSION_STRING \"${VERSION_STRING}\"\n"
               "#endif\n"
    )
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/version_string.hpp ${vstring} )
    set(MY_VERSION ${VERSION_STRING})
    set(version_string ${VERSION_STRING})
  else()
    include(version_string.cmake)
    # now parse the git commit id:
    string(REGEX REPLACE "([0-9]+).*" "\\1" GIT_MAJOR_VERSION "${GIT_COMMIT_ID}" )
    string(REGEX REPLACE "[0-9]+.([0-9]+)-.*" "\\1" GIT_MINOR_VERSION "${GIT_COMMIT_ID}" )
    string(REGEX REPLACE "[0-9]+.[0-9]+-(.*)-.*" "\\1" GIT_PATCH_VERSION "${GIT_COMMIT_ID}" )
    set(MY_VERSION "${GIT_MAJOR_VERSION}.${GIT_MINOR_VERSION}.${GIT_PATCH_VERSION}" CACHE STRING "name")
    set(version_string ${CMAKE_CURRENT_BINARY_DIR}/version_string.hpp)
  endif()
endif()

message(STATUS "OpenCAMLib version: ${MY_VERSION}")

# this defines the source-files
set(OCL_SRC
  ${PROJECT_SOURCE_DIR}/ocl.cpp
  )

set(OCL_GEO_SRC
  ${PROJECT_SOURCE_DIR}/geo/arc.cpp
  ${PROJECT_SOURCE_DIR}/geo/bbox.cpp
  ${PROJECT_SOURCE_DIR}/geo/ccpoint.cpp
  ${PROJECT_SOURCE_DIR}/geo/clpoint.cpp
  ${PROJECT_SOURCE_DIR}/geo/line.cpp
  ${PROJECT_SOURCE_DIR}/geo/path.cpp
  ${PROJECT_SOURCE_DIR}/geo/point.cpp
  ${PROJECT_SOURCE_DIR}/geo/stlreader.cpp
  ${PROJECT_SOURCE_DIR}/geo/stlsurf.cpp
  ${PROJECT_SOURCE_DIR}/geo/triangle.cpp
  )

set(OCL_CUTTER_SRC
  ${PROJECT_SOURCE_DIR}/cutters/ballcutter.cpp
  ${PROJECT_SOURCE_DIR}/cutters/bullcutter.cpp
  ${PROJECT_SOURCE_DIR}/cutters/compositecutter.cpp
  ${PROJECT_SOURCE_DIR}/cutters/conecutter.cpp
  ${PROJECT_SOURCE_DIR}/cutters/millingcutter.cpp
  ${PROJECT_SOURCE_DIR}/cutters/cylcutter.cpp
  ${PROJECT_SOURCE_DIR}/cutters/ellipse.cpp
  ${PROJECT_SOURCE_DIR}/cutters/ellipseposition.cpp
  )

set(OCL_DROPCUTTER_SRC
  ${PROJECT_SOURCE_DIR}/dropcutter/batchdropcutter.cpp
  ${PROJECT_SOURCE_DIR}/dropcutter/pointdropcutter.cpp
  ${PROJECT_SOURCE_DIR}/dropcutter/pathdropcutter.cpp
  ${PROJECT_SOURCE_DIR}/dropcutter/adaptivepathdropcutter.cpp
  )

set(OCL_ALGO_SRC
  ${PROJECT_SOURCE_DIR}/algo/batchpushcutter.cpp
  ${PROJECT_SOURCE_DIR}/algo/fiberpushcutter.cpp
  ${PROJECT_SOURCE_DIR}/algo/interval.cpp
  ${PROJECT_SOURCE_DIR}/algo/fiber.cpp
  ${PROJECT_SOURCE_DIR}/algo/waterline.cpp
  ${PROJECT_SOURCE_DIR}/algo/adaptivewaterline.cpp
  ${PROJECT_SOURCE_DIR}/algo/weave.cpp
  ${PROJECT_SOURCE_DIR}/algo/simple_weave.cpp
  ${PROJECT_SOURCE_DIR}/algo/smart_weave.cpp
  )

set(OCL_COMMON_SRC
  ${PROJECT_SOURCE_DIR}/common/numeric.cpp
  ${PROJECT_SOURCE_DIR}/common/lineclfilter.cpp
  )

set(OCL_INCLUDE_FILES
  ${PROJECT_SOURCE_DIR}/ocl.hpp

  ${PROJECT_SOURCE_DIR}/geo/arc.hpp
  ${PROJECT_SOURCE_DIR}/geo/bbox.hpp
  ${PROJECT_SOURCE_DIR}/geo/ccpoint.hpp
  ${PROJECT_SOURCE_DIR}/geo/clpoint.hpp
  ${PROJECT_SOURCE_DIR}/geo/line.hpp
  ${PROJECT_SOURCE_DIR}/geo/path.hpp
  ${PROJECT_SOURCE_DIR}/geo/stlreader.hpp
  ${PROJECT_SOURCE_DIR}/geo/stlsurf.hpp
  ${PROJECT_SOURCE_DIR}/geo/triangle.hpp
  ${PROJECT_SOURCE_DIR}/geo/point.hpp

  ${PROJECT_SOURCE_DIR}/cutters/ballcutter.hpp
  ${PROJECT_SOURCE_DIR}/cutters/bullcutter.hpp
  ${PROJECT_SOURCE_DIR}/cutters/compositecutter.hpp
  ${PROJECT_SOURCE_DIR}/cutters/conecutter.hpp
  ${PROJECT_SOURCE_DIR}/cutters/cylcutter.hpp
  ${PROJECT_SOURCE_DIR}/cutters/ellipseposition.hpp
  ${PROJECT_SOURCE_DIR}/cutters/millingcutter.hpp
  ${PROJECT_SOURCE_DIR}/cutters/ellipse.hpp

  ${PROJECT_SOURCE_DIR}/dropcutter/adaptivepathdropcutter.hpp
  ${PROJECT_SOURCE_DIR}/dropcutter/pathdropcutter.hpp
  ${PROJECT_SOURCE_DIR}/dropcutter/batchdropcutter.hpp
  ${PROJECT_SOURCE_DIR}/dropcutter/pointdropcutter.hpp

  ${PROJECT_SOURCE_DIR}/common/brent_zero.hpp
  ${PROJECT_SOURCE_DIR}/common/kdnode.hpp
  ${PROJECT_SOURCE_DIR}/common/kdtree.hpp
  ${PROJECT_SOURCE_DIR}/common/numeric.hpp
  ${PROJECT_SOURCE_DIR}/common/lineclfilter.hpp
  ${PROJECT_SOURCE_DIR}/common/clfilter.hpp
  ${PROJECT_SOURCE_DIR}/common/halfedgediagram.hpp

  ${PROJECT_SOURCE_DIR}/algo/operation.hpp
  ${PROJECT_SOURCE_DIR}/algo/batchpushcutter.hpp
  ${PROJECT_SOURCE_DIR}/algo/fiberpushcutter.hpp
  ${PROJECT_SOURCE_DIR}/algo/fiber.hpp
  ${PROJECT_SOURCE_DIR}/algo/interval.hpp
  ${PROJECT_SOURCE_DIR}/algo/waterline.hpp
  ${PROJECT_SOURCE_DIR}/algo/adaptivewaterline.hpp
  ${PROJECT_SOURCE_DIR}/algo/weave.hpp
  ${PROJECT_SOURCE_DIR}/algo/simple_weave.hpp
  ${PROJECT_SOURCE_DIR}/algo/smart_weave.hpp
  ${PROJECT_SOURCE_DIR}/algo/weave_typedef.hpp
  ${PROJECT_SOURCE_DIR}/algo/tsp.hpp
  )

# this branches into the dirs and compiles stuff there
add_subdirectory(${PROJECT_SOURCE_DIR}/cutters)
add_subdirectory(${PROJECT_SOURCE_DIR}/geo)
add_subdirectory(${PROJECT_SOURCE_DIR}/algo)
add_subdirectory(${PROJECT_SOURCE_DIR}/dropcutter)
add_subdirectory(${PROJECT_SOURCE_DIR}/common)

if(BUILD_NODEJS_LIB)
  include(${CMAKE_CURRENT_SOURCE_DIR}/nodejslib/nodejslib.cmake)
endif()

if(BUILD_PY_LIB)
  include(${CMAKE_CURRENT_SOURCE_DIR}/pythonlib/pythonlib.cmake)
endif()

if(BUILD_CXX_LIB)
  include(${CMAKE_CURRENT_SOURCE_DIR}/cxxlib/cxxlib.cmake)
endif()

if(BUILD_EMSCRIPTEN_LIB)
  include(${CMAKE_CURRENT_SOURCE_DIR}/emscriptenlib/emscriptenlib.cmake)
endif()

# build & install documentation (if Doxygen is available)
if(BUILD_DOC)
  find_package(Doxygen)
  if(DOXYGEN_FOUND)
    message(STATUS "Found doxygen. Documentation can be built with 'make doc' ")
    find_package(LATEX)
    if(NOT LATEX_COMPILER)
      message(STATUS "latex command LATEX_COMPILER not found but usually required. You will probably get warnings and user inetraction on doxy run.")
    endif()
    if(NOT MAKEINDEX_COMPILER)
      message(STATUS "makeindex command MAKEINDEX_COMPILER not found but usually required.")
    endif()
    if(NOT DVIPS_CONVERTER)
      message(STATUS "dvips command DVIPS_CONVERTER not found but usually required.")
    endif()

    configure_file(${PROJECT_SOURCE_DIR}/Doxyfile ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile COPYONLY)
    set(DOXY_CONFIG ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    execute_process(

=== src/algo/CMakeLists.txt ===
# CmakeLists.txt for OpenCAMLib src/algo directory

message(STATUS " configuring src/algo")

if (UNIX)
  add_definitions(-fPIC)
endif (UNIX)

include_directories( ${PROJECT_SOURCE_DIR} )
include_directories( ${PROJECT_SOURCE_DIR}/geo )
include_directories( ${PROJECT_SOURCE_DIR}/cutters )
include_directories( ${PROJECT_SOURCE_DIR}/algo )
include_directories( ${PROJECT_SOURCE_DIR}/common )

#
# this builds a static ocl_algo target
#

add_library(
  ocl_algo
  STATIC
  ${OCL_ALGO_SRC}
  )

=== src/common/CMakeLists.txt ===
# CmakeLists.txt for OpenCAMLib src/common directory

message(STATUS " configuring src/common")

if (UNIX)
    add_definitions(-fPIC)
endif (UNIX)

include_directories( ${PROJECT_SOURCE_DIR} )
include_directories( ${PROJECT_SOURCE_DIR}/geo )
include_directories( ${PROJECT_SOURCE_DIR}/algo )
include_directories( ${PROJECT_SOURCE_DIR}/dropcutter )
include_directories( ${PROJECT_SOURCE_DIR}/cutters )
include_directories( ${PROJECT_SOURCE_DIR}/common )

add_library(
    ocl_common
    STATIC
    ${OCL_COMMON_SRC}
)

=== src/cutters/CMakeLists.txt ===
# CmakeLists.txt for OpenCAMLib src/cutters directory

message(STATUS " configuring src/cutters")

if (UNIX)
    add_definitions(-fPIC)
endif (UNIX)

include_directories( ${PROJECT_SOURCE_DIR} )
include_directories( ${PROJECT_SOURCE_DIR}/geo )
include_directories( ${PROJECT_SOURCE_DIR}/algo )
include_directories( ${PROJECT_SOURCE_DIR}/common )

add_library(
    ocl_cutters 
    STATIC
    ${OCL_CUTTER_SRC}
)

=== src/dropcutter/CMakeLists.txt ===
# CmakeLists.txt for OpenCAMLib src/dropcutter directory

message(STATUS " configuring src/dropcutter")

if (UNIX)
    add_definitions(-fPIC)
endif (UNIX)

include_directories( ${PROJECT_SOURCE_DIR} )
include_directories( ${PROJECT_SOURCE_DIR}/geo )
include_directories( ${PROJECT_SOURCE_DIR}/algo )
include_directories( ${PROJECT_SOURCE_DIR}/dropcutter )
include_directories( ${PROJECT_SOURCE_DIR}/cutters )
include_directories( ${PROJECT_SOURCE_DIR}/common )

add_library(
    ocl_dropcutter
    STATIC
    ${OCL_DROPCUTTER_SRC}
)

=== src/geo/CMakeLists.txt ===
# CmakeLists.txt for OpenCAMLib src/geo directory

message(STATUS " configuring src/geo")

if (UNIX)
    add_definitions(-fPIC)
endif (UNIX)


include_directories( ${PROJECT_SOURCE_DIR} )
include_directories( ${PROJECT_SOURCE_DIR}/cutters )
include_directories( ${PROJECT_SOURCE_DIR}/algo )
include_directories( ${PROJECT_SOURCE_DIR}/geo )
include_directories( ${PROJECT_SOURCE_DIR}/common )

#
# this makes the ocl Python module
#

add_library(
    ocl_geo
    STATIC
    ${OCL_GEO_SRC}
)

=== examples/cpp/point/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.15)

cmake_policy(SET CMP0025 NEW)
set(CMAKE_CXX_STANDARD 20)

project(OCL_POINT_EXAMPLE)

# install targets in root of the build dir, using $<0:> generator expression to force it from not being overwritten
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
endforeach()

find_package(OpenCAMLib REQUIRED)

set(EXAMPLE_SRC
  ${PROJECT_SOURCE_DIR}/point_example.cpp
)

add_executable(
  point_example
  ${EXAMPLE_SRC}
)

target_link_libraries(
  point_example
  OpenCAMLib::ocl
)

if(WIN32)
  add_custom_command(TARGET point_example POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_RUNTIME_DLLS:point_example> $<TARGET_FILE_DIR:point_example>
    COMMAND_EXPAND_LISTS
  )
endif()

=== examples/cpp/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.15)

cmake_policy(SET CMP0025 NEW)
set(CMAKE_CXX_STANDARD 20)

project(OCL_TEST_EXAMPLE)

# install targets in root of the build dir, using $<0:> generator expression to force it from not being overwritten
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<0:>)
foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/$<0:>)
endforeach()

find_package(OpenCAMLib REQUIRED)

set(EXAMPLE_SRC
  ${PROJECT_SOURCE_DIR}/test_example.cpp
)

add_executable(
  test_example
  ${EXAMPLE_SRC}
)

target_link_libraries(
  test_example
  OpenCAMLib::ocl
)

if(WIN32)
  add_custom_command(TARGET test_example POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_RUNTIME_DLLS:test_example> $<TARGET_FILE_DIR:test_example>
    COMMAND_EXPAND_LISTS
  )
endif()

=== debian/changelog ===
opencamlib (2023.01.11-5build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 22:35:56 +0000

opencamlib (2023.01.11-5) unstable; urgency=medium

  * Team upload.

  * Added Build-Depends-Indep on ghostscript for generating
    documentation images.
  * Updated Standards-Version from 4.6.2 to 4.7.0.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 09 Apr 2024 08:32:45 +0200

opencamlib (2023.01.11-4) unstable; urgency=medium

  * Team upload.

  * Adjusted C++ autopkgtest check to only depend on libopencamlib-dev.
  * Added recommended multi-arch fields.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 06 Sep 2023 08:28:10 +0200

opencamlib (2023.01.11-3) unstable; urgency=medium

  * Team upload.

  * Corrected arch:all builds by only using the opencamlib-doc.docs
    content for installation.
  * Updated formatting for debian/patches/*.patch.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 03 Sep 2023 14:14:28 +0200

opencamlib (2023.01.11-2) unstable; urgency=medium

  * Team upload.

  * Updated Standards-Version from 4.2.1 to 4.6.2.  No changes needed.
  * Corrected 1000-fix-python-paths.patch to install python library
    in opencamlib subdirectory.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 03 Sep 2023 08:38:34 +0200

opencamlib (2023.01.11-1) unstable; urgency=medium

  * Team upload.

  [ Petter Reinholdtsen ]
  * Use annotation in d/patches/.
  * New upstream version 2023.01.11
  * Updated patches and build rules for version 2023.01.11.
  * Dropped 1000-fix-python-paths.patch.

  [ Daniel Gröber ]
  * Upgrade debhelper compat to 13
  * Patch to fix doc target
  * Fix package build by building twice
  * Use DEB_VERSION to fetch version string
  * Replace `which` with command -v
  * Remove unused make vars
  * Fix autopkgtest badpkg error
  * Add autopkgtest building cxx lib example

  [ Petter Reinholdtsen ]
  * Corrected python autopkgtest script to work with python 3
    and new library name.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 27 Aug 2023 07:48:47 +0200

opencamlib (2019.07+dfsg1-2) unstable; urgency=medium

  * Team upload.

  [ Kurt Kremitzki ]
  * Remove debian/files
  * New upstream version 2019.07+dfsg1
  * Add missing texlive-plain-generic dep

  [ Petter Reinholdtsen ]
  * Added gbp.conf to enforce the use or pristine-tar.
  * Adjusted d/copyright shortname from LGPL-2.1 to LGPL-2.1+.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 26 Aug 2023 14:20:01 +0200

opencamlib (2019.07+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Remove Python 2 bindings, build Python 3 bindings

 -- Sabin Iacob <iacobs@m0n5t3r.info>  Sun, 23 Feb 2020 16:17:38 +0200

opencamlib (2018.08+dfsg1-1) unstable; urgency=medium

  * Initial release. (Closes: #905460)
  * Includes Python 2 version.

 -- Kurt Kremitzki <kurt@kwk.systems>  Wed, 29 Aug 2018 01:33:40 -0500

=== debian/control ===
Source: opencamlib
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kurt Kremitzki <kurt@kwk.systems>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libboost-graph-dev,
               libboost-python-dev,
               libboost-system-dev,
               python3-all-dev,
Build-Depends-Indep: doxygen,
                     ghostscript,
                     texlive-fonts-recommended,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-plain-generic
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/opencamlib
Vcs-Git: https://salsa.debian.org/science-team/opencamlib.git
Homepage: http://www.anderswallin.net/cam/

Package: libopencamlib-2023.01
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: libopencamlib
Conflicts: libopencamlib,
           libopencamlib-2018.08,
           libopencamlib-2019.07,
Replaces: libopencamlib
Suggests: opencamlib-doc
Multi-Arch: same
Description: C++ library for creating 3D toolpaths for CNC machines
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.

Package: libopencamlib-dev
Architecture: any
Section: libdevel
Depends: libopencamlib-2023.01 (<< ${binary:Version}+1~),
         libopencamlib-2023.01 (>= ${binary:Version}),
         ${misc:Depends}
Description: C++ library for creating 3D toolpaths for CNC machines - headers
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.
 .
 This package provides development headers for OpenCAMLib.

Package: python3-opencamlib
Section: python
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: opencamlib-doc
Description: C++ library for creating 3D toolpaths for CNC machines - Python bindings
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.
 .
 This package contains the Python bindings for OpenCAMLib.

Package: opencamlib-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: python3-opencamlib
Multi-Arch: foreign
Description: C++ library for creating 3D toolpaths for CNC machine - documentation
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.
 .
 This package contains documentation for OpenCAMLib.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

extra_flags += \
-DCMAKE_BUILD_TYPE=Release \
-DCMAKE_CXX_FLAGS="-Wall -fpermissive $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
-DCMAKE_C_FLAGS="-Wall -fpermissive $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
-DCMAKE_SHARED_LINKER_FLAGS="$(shell dpkg-buildflags --get LDFLAGS)" \
-DMY_VERSION=$(DEB_VERSION) \
-DUSE_PY_3="ON" \
-DPYTHON_EXECUTABLE="$(shell command -v python3)" \
-DPYTHON_VERSION_SUFFIX=3

COMPONENTS = cxx py

override_dh_auto_configure:
	dh_auto_configure --builddirectory=obj-cxx/ -- $(extra_flags) -DBUILD_PY_LIB=OFF -DBUILD_CXX_LIB=ON -DBUILD_DOC=ON
	dh_auto_configure --builddirectory=obj-py/ -- $(extra_flags) -DBUILD_PY_LIB=ON -DBUILD_DOC=OFF

override_dh_auto_build-arch:
	$(foreach comp,$(COMPONENTS),dh_auto_build --builddirectory=obj-$(comp)/;)

override_dh_auto_build-indep:
	dh_auto_build --builddirectory=obj-cxx/ -- doc

override_dh_auto_test:
	$(foreach comp,$(COMPONENTS),dh_auto_test --builddirectory=obj-$(comp)/;)

override_dh_auto_install-arch:
	$(foreach comp,$(COMPONENTS),dh_auto_install --builddirectory=obj-$(comp)/;)

# No-op, installed using opencamlib-doc.docs
override_dh_auto_install-indep:

override_dh_auto_clean:
	rm -rf obj-*/

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg1,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://github.com/aewallin/opencamlib/tags .*/(\d.*).*(?<!_pre)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)) debian uupdate
